--- spyderlib/widgets/shell.py.orig	2012-07-18 15:55:19.000000000 -0500
+++ spyderlib/widgets/shell.py	2012-07-18 15:58:31.000000000 -0500
@@ -227,11 +227,13 @@
         
     #------ Copy / Keyboard interrupt
     def copy(self):
-        """Copy text to clipboard... or keyboard interrupt"""
+        """Copy text to clipboard"""
         if self.has_selected_text():
             ConsoleBaseWidget.copy(self)
-        else:
-            self.emit(SIGNAL("keyboard_interrupt()"))
+            
+    def interrupt(self):
+        """Keyboard interrupt"""
+        self.emit(SIGNAL("keyboard_interrupt()"))
             
     def cut(self):
         """Cut text"""
@@ -305,9 +307,12 @@
         # Copy must be done first to be able to copy read-only text parts
         # (otherwise, right below, we would remove selection
         #  if not on current line)
-        ctrl = event.modifiers() & Qt.ControlModifier
-        if event.key() == Qt.Key_C and ctrl:
-            self.copy()
+        if event.key() == Qt.Key_C and ((Qt.MetaModifier | Qt.ControlModifier) &
+                                        event.modifiers()):
+            if event.modifiers() & Qt.MetaModifier: # OSX: Meta = control
+              self.interrupt()
+            elif event.modifiers() & Qt.ControlModifier: # Control = command
+              self.copy()
             event.accept()
             return True
         
